/*## (c) SECURITY EXPLORATIONS    2018 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.io.*;
import java.util.*;
import javax.crypto.*;
import javax.crypto.spec.*;

public class Issue33 {
 public static final String scid    = STBConfig.scid;
 public static final String cid     = STBConfig.cid;
 public static final long timeout   = 9999999999L;

 static byte key[] = {
  38, 36, -51, -4, -46, 107, -72, -4, -43, -98, 100, 60, -59, 112, 18, -7
 };

 static byte iv[] = {
  0, 1, 2, 5, 3, 4, 6, 11, 8, 9, 7, 10, 12, 14, 13, 15
 };

 public static byte[] aes_encrypt(byte data[]) {
  byte res[]=null;

  try {
   Cipher cipher=Cipher.getInstance("AES/CBC/PKCS5Padding");
   cipher.init(Cipher.ENCRYPT_MODE,new SecretKeySpec(key,"AES"),new IvParameterSpec(iv));

   res=cipher.doFinal(data);
  } catch(Throwable t) {t.printStackTrace();}

  return res;
 }

 public static byte[] prepare_multiroom_auth_response() {
  byte res[]=null;

  try {
   long curtime=System.currentTimeMillis();
   System.out.println(new Date(curtime));

   curtime+=timeout*1000L;

   String msg="";
   msg+="<multibox timeout=\""+curtime+"\"/>\n";
   msg+=" <client scid=\""+scid+"\" cid=\""+cid+"\"/>\n";
   msg+="</multibox>";

   System.out.println(msg);
 
   byte data[]=msg.getBytes();

   res=aes_encrypt(data);
  } catch(Throwable t) {t.printStackTrace();}

  return res;
 }

}
